annotate test/test-server.sh @ 129:3ae0335cfe60

Do simpler format first
author Chris Cannam <c.cannam@qmul.ac.uk>
date Wed, 02 Nov 2016 18:26:33 +0000
parents 5b113c87b6e6
children a9be6f1e680d
rev   line source
c@75 1 #!/bin/bash
c@75 2
c@75 3 set -eu
c@75 4
c@75 5 piperdir=../piper
c@75 6 vampsdkdir=../vamp-plugin-sdk
c@75 7 schemadir="$piperdir"/json/schema
c@75 8
c@116 9 tmpdir=$(mktemp -d)
c@116 10
c@116 11 if [ ! -d "$tmpdir" ]; then
c@116 12 echo "Temp directory creation failed" 1>&2
c@116 13 exit 1
c@116 14 fi
c@116 15
c@116 16 trap "rm -rf $tmpdir" 0
c@116 17
c@116 18 reqfile="$tmpdir/req.json"
c@116 19 respfile="$tmpdir/resp.json"
c@116 20 allrespfile="$tmpdir/resp.all"
c@116 21 input="$tmpdir/input"
c@116 22 expected="$tmpdir/expected"
c@116 23 obtained="$tmpdir/obtained"
c@75 24
c@75 25 validate() {
c@75 26 local file="$1"
c@75 27 local schemaname="$2"
c@75 28 jsonschema -i "$file" "$schemadir/$schemaname.json" 1>&2 && \
c@75 29 echo "validated $schemaname" 1>&2 || \
c@75 30 echo "failed to validate $schemaname" 1>&2
c@75 31 }
c@75 32
c@75 33 validate_request() {
c@75 34 local json="$1"
c@75 35 echo "$json" > "$reqfile"
c@75 36 validate "$reqfile" "rpcrequest"
c@75 37 }
c@75 38
c@75 39 validate_response() {
c@75 40 local json="$1"
c@75 41 echo "$json" > "$respfile"
c@75 42 validate "$respfile" "rpcresponse"
c@75 43 }
c@75 44
c@116 45 cat > "$input" <<EOF
c@75 46 {"method":"list"}
c@127 47 {"method":"list","params": {"from":["vamp-example-plugins","something-nonexistent"]}}
c@127 48 {"method":"list","params": {"from":["something-nonexistent"]}}
c@75 49 {"method":"load","id":6,"params": {"key":"vamp-example-plugins:percussiononsets","inputSampleRate":44100,"adapterFlags":["AdaptInputDomain","AdaptBufferSize"]}}
c@75 50 {"method":"configure","id":"weevil","params":{"handle":1,"configuration":{"blockSize": 8, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 8}}}
c@75 51 {"method":"process","params": {"handle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [ [1,2,3,4,5,6,7,8] ]}}}
c@75 52 {"method":"finish","params": {"handle": 1}}
c@75 53 EOF
c@75 54
c@75 55 # Expected output, apart from the plugin list which seems a bit
c@75 56 # fragile to check here
c@75 57 cat > "$expected" <<EOF
c@75 58 {"id": 6, "jsonrpc": "2.0", "method": "load", "result": {"defaultConfiguration": {"blockSize": 1024, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 1024}, "handle": 1, "staticData": {"basic": {"description": "Detect percussive note onsets by identifying broadband energy rises", "identifier": "percussiononsets", "name": "Simple Percussion Onset Detector"}, "basicOutputInfo": [{"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}], "category": ["Time", "Onsets"], "copyright": "Code copyright 2006 Queen Mary, University of London, after Dan Barry et al 2005. Freely redistributable (BSD license)", "inputDomain": "TimeDomain", "key": "vamp-example-plugins:percussiononsets", "maker": "Vamp SDK Example Plugins", "maxChannelCount": 1, "minChannelCount": 1, "parameters": [{"basic": {"description": "Energy rise within a frequency bin necessary to count toward broadband total", "identifier": "threshold", "name": "Energy rise threshold"}, "defaultValue": 3, "extents": {"max": 20, "min": 0}, "unit": "dB", "valueNames": []}, {"basic": {"description": "Sensitivity of peak detector applied to broadband detection function", "identifier": "sensitivity", "name": "Sensitivity"}, "defaultValue": 40, "extents": {"max": 100, "min": 0}, "unit": "%", "valueNames": []}], "programs": [], "version": 2}}}
c@75 59 {"id": "weevil", "jsonrpc": "2.0", "method": "configure", "result": {"handle": 1, "outputList": [{"basic": {"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, "configured": {"binCount": 0, "binNames": [], "hasDuration": false, "sampleRate": 44100, "sampleType": "VariableSampleRate", "unit": ""}}, {"basic": {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}, "configured": {"binCount": 1, "binNames": [""], "hasDuration": false, "quantizeStep": 1, "sampleRate": 86.1328125, "sampleType": "FixedSampleRate", "unit": ""}}]}}
c@75 60 {"jsonrpc": "2.0", "method": "process", "result": {"features": {}, "handle": 1}}
c@75 61 {"jsonrpc": "2.0", "method": "finish", "result": {"features": {"detectionfunction": [{"featureValues": [0], "timestamp": {"n": 11609977, "s": 0}}]}, "handle": 1}}
c@75 62 EOF
c@75 63
c@116 64 # We run the whole test twice, once with the server in Capnp mode
c@116 65 # (converting to JSON using piper-convert) and once with it directly
c@116 66 # in JSON mode
c@75 67
c@129 68 for format in json capnp ; do
c@75 69
c@117 70 ( export VAMP_PATH="$vampsdkdir"/examples ;
c@117 71 while read request ; do
c@116 72 validate_request "$request"
c@116 73 echo "$request"
c@116 74 done |
c@116 75 if [ "$format" = "json" ]; then
c@125 76 bin/piper-vamp-simple-server -d json
c@116 77 else
c@116 78 bin/piper-convert request -i json -o capnp |
c@125 79 bin/piper-vamp-simple-server -d capnp |
c@116 80 bin/piper-convert response -i capnp -o json
c@116 81 fi |
c@116 82 while read response ; do
c@116 83 echo "$response" >> "$allrespfile"
c@116 84 validate_response "$response"
c@116 85 done
c@116 86 ) < "$input"
c@116 87
c@127 88 # Skip plugin lists
c@127 89 tail -n +4 "$allrespfile" > "$obtained"
c@116 90
c@116 91 echo "Checking response contents against expected contents..."
c@116 92 if ! cmp "$obtained" "$expected"; then
c@116 93 diff -u1 "$obtained" "$expected"
c@116 94 else
c@116 95 echo "OK"
c@116 96 fi
c@116 97
c@127 98 echo "Checking plugin counts from list responses..."
c@127 99
c@127 100 # Now check the plugin lists, but as the descriptions etc are
c@127 101 # probably a bit fragile, let's just count the number of plugins
c@127 102
c@127 103 # First, with no "from" arg to the list call
c@127 104 list_no_from=$(head -n +1 "$allrespfile" | fmt -1 | grep '"key"' | wc -l)
c@127 105
c@127 106 # Now with a "from" arg that includes the library that exists
c@127 107 list_with_good_from=$(tail -n +2 "$allrespfile" | head -n +1 | fmt -1 |
c@127 108 grep '"key"' | wc -l)
c@127 109
c@127 110 # Now with a "from" arg that doesn't include any real library
c@127 111 list_with_bad_from=$(tail -n +3 "$allrespfile" | head -n +1 | fmt -1 |
c@127 112 grep '"key"' | wc -l)
c@127 113
c@127 114 if [ "$list_no_from" != "6" ]; then
c@127 115 echo "Wrong number of plugins from list response without \"from\" arg"
c@127 116 echo "Expected 6, obtained $list_no_from"
c@127 117 false
c@127 118 fi
c@127 119 if [ "$list_with_good_from" != "6" ]; then
c@127 120 echo "Wrong number of plugins from list response with good \"from\" arg"
c@127 121 echo "Expected 6, obtained $list_with_good_from"
c@127 122 false
c@127 123 fi
c@127 124 if [ "$list_with_bad_from" != "0" ]; then
c@127 125 echo "Wrong number of plugins from list response with bad \"from\" arg"
c@127 126 echo "Expected 0, obtained $list_with_bad_from"
c@127 127 false
c@127 128 fi
c@127 129 echo OK
c@127 130
c@116 131 rm "$allrespfile"
c@116 132
c@116 133 done
c@127 134
c@127 135 echo "Tests succeeded" # set -e at top should ensure we don't get here otherwise